#!/bin/bash
#
# updates by WIPAT 2554-09-01
#
###exit 0 = valid ; exit 1 = invalid

CHECK_BLACKLIST="YES"
ALL_PASS="YES"
CHECK_VIPLIST="NO"
CHECK_PSU_STAFF="NO"
CHECK_PSU_STUDENT="NO"
BLACKLIST_FILE="/etc/freeradius/blacklist.txt"
VIP_FILE="/etc/freeradius/viplist.txt"

export LANG=en.US
MYDIR="/var/log/freeradius/myauthen"
if [ ! -d ${MYDIR} ] ; then
  mkdir -p ${MYDIR}
fi
TODAY=$(date "+%Y%m%d")
MYFILE="${MYDIR}/${TODAY}"
if [ ! -e ${MYFILE} ] ; then
  touch ${MYFILE}
fi
MYTIME=$(echo $1|awk '{print strftime("%Y%m%d:%H:%M:%S",$1)}')
echo "${MYTIME};${USER_NAME};$2;$1;PASS" >> ${MYFILE}
MYUSER=$(echo $USER_NAME | cut -d'"' -f2)
if [ "${CHECK_BLACKLIST}" = "YES" ] ; then
  if [ -s ${BLACKLIST_FILE} ] ; then
    OUTPUT=$(grep "^${MYUSER}\$" ${BLACKLIST_FILE})
    if [ -n "${OUTPUT}" ] ; then
      echo "${MYTIME};${USER_NAME};$2;$1;BLACKLIST" >> ${MYFILE}
      exit 1
    fi
  fi
fi
if [ "${CHECK_VIPLIST}" = "YES" ] ; then
  if [ -s ${VIP_FILE} ] ; then
    OUTPUT=$(grep "^${MYUSER}\$" ${VIP_FILE})
    if [ -n "${OUTPUT}" ] ; then
      exit 0
    fi
  fi
fi
if [ "${CHECK_PSU_STAFF}" = "YES" ] ; then
  OUTPUT=$(echo "${MYUSER}"|grep "@")
  if [ -z "${OUTPUT}" ] ; then
    OUTPUT=$(echo "${MYUSER}"|grep "^[[:digit:]]")
    if [ -z "${OUTPUT}" ] ; then
      exit 0
    fi
  else
    OUTPUT=$(echo "${MYUSER}"|grep "psu.ac.th")
    if [ -n "${OUTPUT}" ] ; then
      exit 0
    fi
  fi
fi
if [ "${CHECK_PSU_STUDENT}" = "YES" ] ; then
  OUTPUT=$(echo "${MYUSER}"|grep "@")
  if [ -z "${OUTPUT}" ] ; then
    MYSTUDENT="....."
#    MYSTUDENT="..105"
    OUTPUT=$(echo "${MYUSER}"|grep "^${MYSTUDENT}")
    if [ -n "${OUTPUT}" ] ; then
      exit 0
    fi
  fi
fi
if [ "${ALL_PASS}" = "YES" ] ; then
  exit 0
fi 
echo "${MYTIME};${USER_NAME};$2;$1;INVALID" >> ${MYFILE}
exit 1
